import * as t from 'io-ts';
import * as Region_ad49_ from '../../core/region';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/customers/personalDataCatalogue.json";
export type RegionRestriction = t.Branded<Array<Region_ad49_.RegionId>, RegionRestrictionBrand>;
export type RegionRestrictionC = t.BrandC<t.ArrayC<typeof Region_ad49_.RegionId>, RegionRestrictionBrand>;
export declare const RegionRestriction: RegionRestrictionC;
export type RegionRestrictionBrand = {
    readonly RegionRestriction: unique symbol;
};
export type DependsOnRestriction = t.Branded<({
    name?: string;
    values?: Array<string>;
} & Record<string, unknown>) & {
    name: Defined;
}, DependsOnRestrictionBrand>;
export type DependsOnRestrictionC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            name: t.StringC;
            values: t.ArrayC<t.StringC>;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        name: typeof Defined;
    }>
]>, DependsOnRestrictionBrand>;
export declare const DependsOnRestriction: DependsOnRestrictionC;
export type DependsOnRestrictionBrand = {
    readonly DependsOnRestriction: unique symbol;
};
export type PersonalDataCatalogueItem = t.Branded<{
    name?: string;
    type?: string & ('string' | 'ISODate' | 'email' | 'phone' | 'locale');
    enum?: Array<string>;
    canShowPlain?: boolean;
    isReadOnly?: boolean;
    description?: string;
    regionRestriction?: RegionRestriction;
    dependsOn?: Array<DependsOnRestriction>;
} & {
    name: Defined;
    type: Defined;
    canShowPlain: Defined;
    isReadOnly: Defined;
}, PersonalDataCatalogueItemBrand>;
export type PersonalDataCatalogueItemC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        name: t.StringC;
        type: t.IntersectionC<[
            t.StringC,
            t.UnionC<[
                t.LiteralC<'string'>,
                t.LiteralC<'ISODate'>,
                t.LiteralC<'email'>,
                t.LiteralC<'phone'>,
                t.LiteralC<'locale'>
            ]>
        ]>;
        enum: t.ArrayC<t.StringC>;
        canShowPlain: t.BooleanC;
        isReadOnly: t.BooleanC;
        description: t.StringC;
        regionRestriction: typeof RegionRestriction;
        dependsOn: t.ArrayC<typeof DependsOnRestriction>;
    }>,
    t.TypeC<{
        name: typeof Defined;
        type: typeof Defined;
        canShowPlain: typeof Defined;
        isReadOnly: typeof Defined;
    }>
]>, PersonalDataCatalogueItemBrand>;
export declare const PersonalDataCatalogueItem: PersonalDataCatalogueItemC;
export type PersonalDataCatalogueItemBrand = {
    readonly PersonalDataCatalogueItem: unique symbol;
};
export type PersonalDataCatalogue = t.Branded<unknown, PersonalDataCatalogueBrand>;
export type PersonalDataCatalogueC = t.BrandC<t.UnknownC, PersonalDataCatalogueBrand>;
export declare const PersonalDataCatalogue: PersonalDataCatalogueC;
export type PersonalDataCatalogueBrand = {
    readonly PersonalDataCatalogue: unique symbol;
};
export default PersonalDataCatalogue;
